package nl.tue.id.zoo.animal;

import nl.tue.id.zoo.food.*;
import nl.tue.id.zoo.ui.*;
import nl.tue.id.zoo.util.*;
import nl.tue.id.zoo.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
abstract public class Animal implements LifeHolder {
    private Life life;
    private double weight;
    private AnimalBody body;

    public Animal() {
        birth();
    }

    private void birth() {
        life = new Life(this);
        body = createBody();
        body.setAnimal(this);
        Zoo.getTheZoo().add(this);
        setBirthWeight();
    }

    protected abstract AnimalBody createBody();

    public AnimalBody getBody() {
        return body;
    }


    public long getAge() {
        return life.howOldAreYou();
    }

    abstract public void move();

    abstract public void eat(Food food);

    public void say(String words) {
        System.out.println(words);
    }


    protected void setWeight(double weight) {
        if (body != null) {
            body.grow((int) ((weight - this.weight) * 10));
        }
        this.weight = weight;
    }

    public double getWeight() {
        return weight;
    }

    protected void setBirthWeight() {
        setWeight(0);
    }


    public void LifeGoesOn() {
        //   say("Happily living animal.");
    }

    public void Sleep() {
        say("Sleeping now");
    }

    public void Getup() {
        say("Getting up now.");
    }

    public void Birthday() {
        beHappy();
        say("Happy birthday to me, I am now " +
            getAge() + " year old, " +
            getWeight() + "kilo big.");
    }

    protected void beHappy() {
        move();
        say(null);
        move();
        say(null);
        move();
        say(null);
    }

    public void sayGoodBye() {
        say("That was it, Amen...");
        Zoo.getTheZoo().remove(this);
    }
}
